org.vishia.gral.base

## Class GralWidget.ImplAccess

- java.lang.Object
- - org.vishia.gral.base.GralWidget.ImplAccess

- All Implemented Interfaces:
    GralWidgImpl_ifc
  Direct Known Subclasses:
    GralButton.GraphicImplAccess, GralCurveView.GraphicImplAccess, GralHorizontalSelector.GraphicImplAccess, GralHtmlBox.ImplAccess, GralLabel.GraphicImplAccess, GralLed.GraphicImplAccess, GralPanelContent.ImplAccess, GralPanelContent.MethodsCalledbackFromImplementation, GralPlotArea._GraphicImplAccess_, GralSlider._GraphicImplAccess_, GralTable.GraphicImplAccess, GralTextField.GraphicImplAccess, GralValueBar.GraphicImplAccess
  Enclosing class:
    GralWidget

      public abstract static class GralWidget.ImplAccess
      extends java.lang.Object
      implements GralWidgImpl_ifc

  Methods which should be called back by events of the implementation layer. This class is used only for the implementation level of the graphic. It is not intent to use by any application. It is public because the implementation level should accesses it.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `chgBitsDerived` This is only documentation.
    `static int` | `chgColorBack` What is changed in the dynamic data, see `GralWidget.DynamicData.whatIsChanged`.
    `static int` | `chgColorLine` What is changed in the dynamic data, see `GralWidget.DynamicData.whatIsChanged`.
    `static int` | `chgColorText` What is changed in the dynamic data, see `GralWidget.DynamicData.whatIsChanged`.
    `static int` | `chgEditable`
    `static int` | `chgFloat`
    `static int` | `chgFocus`
    `static int` | `chgFont` What is changed in the dynamic data, see `GralWidget.DynamicData.whatIsChanged`.
    `static int` | `chgIntg`
    `static int` | `chgInvisible`
    `static int` | `chgObjects`
    `static int` | `chgPos`
    `static int` | `chgText` What is changed in the dynamic data, see `GralWidget.DynamicData.whatIsChanged`.
    `static int` | `chgVisible`
    `static int` | `chgVisibleInfo`
    `GralRectangle` | `pixBounds` Bounds of the implementation widget in its container. null if not used.
    `protected GralWidgetImpl_ifc` | `wdgimpl` Aggregation to the widget implementation which resolves the required implementation methods.
    `GralWidget` | `widgg`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `ImplAccess(GralWidget widgg)` Constructs the base of the graphic implemantion widget wrapper (SWT, AWT).
    `protected` | `ImplAccess(GralWidget widgg, GralMng mng)` Deprecated.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `acknChanged(int mask)`
    `protected GralUserAction` | `actionShow()` Access method to GralWidget's method.
    `protected GralWidget.DynamicData` | `dyda()` Access method to `GralWidget.dyda`.
    `protected GralWidget_ifc.ActionChange` | `getActionChange(GralWidget_ifc.ActionChangeWhen when)`
    `int` | `getChanged()` Gets the bits what is changed in the widget's data.
    `static GralWidget` | `gralWidgetFromImplData(java.lang.Object data)`
    `protected void` | `setDragEnable(int dragType)` Implementation routine to set receiving a drag event and initializes the drag feature of the widget.
    `protected void` | `setDropEnable(int dropType)` Implementation routine to set receiving a drop event and initializes the drop feature of the widget.
    `static void` | `setFocused(GralWidget widgg, boolean focus)` This routine does not change the focus state in the implementation widget, it denotes only that the GralWidget has the focus or not.
    `protected void` | `setTextChanged()` Notify that the text is changed in `GralWidget.DynamicData.bTextChanged`
    `void` | `setVisibleState(boolean visible)` Sets the state of the widget whether it seams to be visible.
    `void` | `XXXfocusGained()` This method is not intent to call by user.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.vishia.gral.base.GralWidgImpl_ifc

      `getPixelPositionSize, getWidgetImplementation, removeWidgetImplementation, repaintGthread, setBoundsPixel, setFocusGThread, setVisibleGThread`

- - ### Field Detail

    - #### chgText

          public static final int chgText

      What is changed in the dynamic data, see `GralWidget.DynamicData.whatIsChanged`.
      See Also:
        Constant Field Values

    - #### chgColorBack

          public static final int chgColorBack

      What is changed in the dynamic data, see `GralWidget.DynamicData.whatIsChanged`.
      See Also:
        Constant Field Values

    - #### chgColorText

          public static final int chgColorText

      What is changed in the dynamic data, see `GralWidget.DynamicData.whatIsChanged`.
      See Also:
        Constant Field Values

    - #### chgFont

          public static final int chgFont

      What is changed in the dynamic data, see `GralWidget.DynamicData.whatIsChanged`.
      See Also:
        Constant Field Values

    - #### chgColorLine

          public static final int chgColorLine

      What is changed in the dynamic data, see `GralWidget.DynamicData.whatIsChanged`.
      See Also:
        Constant Field Values

    - #### chgEditable

          public static final int chgEditable

      See Also:
        Constant Field Values

    - #### chgVisibleInfo

          public static final int chgVisibleInfo

      See Also:
        Constant Field Values

    - #### chgObjects

          public static final int chgObjects

      See Also:
        Constant Field Values

    - #### chgFloat

          public static final int chgFloat

      See Also:
        Constant Field Values

    - #### chgIntg

          public static final int chgIntg

      See Also:
        Constant Field Values

    - #### chgFocus

          public static final int chgFocus

      See Also:
        Constant Field Values

    - #### chgPos

          public static final int chgPos

      See Also:
        Constant Field Values

    - #### chgVisible

          public static final int chgVisible

      See Also:
        Constant Field Values

    - #### chgInvisible

          public static final int chgInvisible

      See Also:
        Constant Field Values

    - #### chgBitsDerived

          public static final int chgBitsDerived

      This is only documentation. These bits are used specialized in derived classes.
      See Also:
        Constant Field Values

    - #### widgg

          public final GralWidget widgg

    - #### wdgimpl

          protected GralWidgetImpl_ifc wdgimpl

      Aggregation to the widget implementation which resolves the required implementation methods.

    - #### pixBounds

          public GralRectangle pixBounds

      Bounds of the implementation widget in its container. null if not used.

  - ### Constructor Detail

    - #### ImplAccess

          @Deprecated
          protected ImplAccess(GralWidget widgg,
                                            GralMng mng)

      Deprecated.

    - #### ImplAccess

          protected ImplAccess(GralWidget widgg)

      Constructs the base of the graphic implemantion widget wrapper (SWT, AWT). Stores the reference to the GralWidget in this.`widgg` Stores the reference to the graphic implementation widget in `GralWidget._wdgImpl` Initializes the pos() from the given `GralMng.pos()` if it is not given by construction.
      Parameters:
        `widgg` - The associated derived class of GralWidget.

  - ### Method Detail

    - #### XXXfocusGained

          public void XXXfocusGained()

      This method is not intent to call by user. It may be called from all widget implementation if the focus of the widget is gained. Use `GralWidget.setFocus()` to set a widget in the focus. It sets the html help for the widget and notifies the widgets in focus for the GralWidgetMng. Don't override this method in the graphic implementation! It should be overridden only in a Gral widget inheritance only if necessary.

    - #### setVisibleState

          public void setVisibleState(boolean visible)

      Sets the state of the widget whether it seams to be visible. This method should not be invoked by the application. It is
      Parameters:
        `visible` -

    - #### actionShow

          protected GralUserAction actionShow()

      Access method to GralWidget's method.

    - #### dyda

          protected GralWidget.DynamicData dyda()

      Access method to `GralWidget.dyda`.

    - #### setTextChanged

          protected void setTextChanged()

      Notify that the text is changed in `GralWidget.DynamicData.bTextChanged`

    - #### setDragEnable

          protected void setDragEnable(int dragType)

      Implementation routine to set receiving a drag event and initializes the drag feature of the widget. A overridden routine should be implemented for the implementation graphic layer widget. This routine is invoked when it isn't overridden, it throws an exception because the drag feature isn't supported for the implementation.
      Parameters:
        `dragType` - one of `KeyCode.dragFiles` or ..dragText

    - #### setDropEnable

          protected void setDropEnable(int dropType)

      Implementation routine to set receiving a drop event and initializes the drop feature of the widget.
      Parameters:
        `dropType` - one of `KeyCode.dropFiles` or ..dropText

    - #### getChanged

          public int getChanged()

      Gets the bits what is changed in the widget's data. The bits are all definitions starting with chg in this class. `chgText` etc.
      Returns:

    - #### acknChanged

          public void acknChanged(int mask)

    - #### getActionChange

          protected GralWidget_ifc.ActionChange getActionChange(GralWidget_ifc.ActionChangeWhen when)

    - #### gralWidgetFromImplData

          public static GralWidget gralWidgetFromImplData(java.lang.Object data)

    - #### setFocused

          public static void setFocused(GralWidget widgg,
                                        boolean focus)

      This routine does not change the focus state in the implementation widget, it denotes only that the GralWidget has the focus or not. The method is static because it gets the widgg instance. Note that it is not member of GralWidget itself because the application should not invoke it (which may be possible on a public GralWidget-method).
      Parameters:
        `widgg` - the GralWidget instance
        `focus` - true on focus gained, false on focus lost.